﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ghost : MonoBehaviour {
	GameObject player;
	public GameObject deathAnim;
	public int health = 100;
	CharacterController controller;
	public float force = 10f;
	public bool canBeDamaged = true;
	public float speed = 10f;
	public bool isHacked = false;

	AudioSource audio;
	public AudioClip invulnerable;
	public AudioClip damage;
	// Use this for initialization
	void Start () {
		//controller = gameObject.GetComponent<CharacterController> ();
		audio = gameObject.GetComponent<AudioSource> ();
		player = universalFunctions.universalObjectSearch ("player");
		gameObject.GetComponent<Rigidbody>().velocity=(Random.onUnitSphere * force);
	}
	
	// Update is called once per frame
	void Update () {
		if (health <= 0) {
			//TD-play death animation
			Instantiate(deathAnim, gameObject.transform.position, Quaternion.identity);

			Destroy (gameObject);
		}
		if (universalFunctions.universalObjectSearch ("sword") == null) {
			canBeDamaged = true;
		}
		gameObject.GetComponent<Rigidbody> ().velocity = speed * (gameObject.GetComponent<Rigidbody> ().velocity.normalized);
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.name.Contains ("sword") && canBeDamaged == true && isHacked == true) {
			canBeDamaged = false;
			float force2 = 0.25f; //force applied when knocking back
			Vector3 dir = -1 * (player.transform.position - gameObject.transform.position);
			gameObject.GetComponent<Rigidbody> ().velocity = (dir * force2);
			audio.clip = damage;
			audio.Play ();
			health -= 34;
			//TD-play damage animation
		} else if (col.gameObject.name.Contains ("sword") && isHacked == false) {
			audio.clip = invulnerable;
			audio.Play ();
		}
		if(col.gameObject.name.Contains("ghosStopper")){
			float force2 = 10f; //force applied when knocking back
			Vector3 dir = -1*(col.transform.position-gameObject.transform.position);
			gameObject.GetComponent<Rigidbody> ().velocity = (dir * force2);
		}
	}
	void OnTriggerExit(Collider col){
		if (col.gameObject.name.Contains ("sword")) {
			canBeDamaged = true;
		}
	}
}
