﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.EventSystems;

public class hackingScript : MonoBehaviour {

	public GameObject hackedObject; // the object that is being hacked
	public GameObject success;//window for successful hack
	public GameObject fail;//window for failed hack
	int mode =0;//mode 1 = skeleton, 2 = ghosts, 3 = moveableBlock
	GameObject viewCode, editCode, player;
	string tempText;

	// Use this for initialization
	void Start () {
		player = universalFunctions.universalObjectSearch ("player");
		player.GetComponent<playerControl> ().speed = 0;
		viewCode = universalFunctions.universalObjectSearch ("viewCode");
		editCode = universalFunctions.universalObjectSearch ("editCode");
		if (hackedObject.name.Contains ("skeleton") && hackedObject.GetComponent<skeleton>().isHacked == false) {
			mode = 1;
			editCode.GetComponent<InputField> ().text =
				"public class sword {\n" +
				"void arrayMaker(){\n" +
				"\tstring[] newArray;\n\n" +
				"\tskeleton.vulnChecker(newArray);\n" +
				"}\n" +
				"}";
			tempText = editCode.GetComponent<InputField> ().text;
			editCode.GetComponent<InputField> ().Select();
			editCode.GetComponent<InputField> ().MoveTextStart (false);
			viewCode.GetComponent<InputField> ().text =
				"public class skeleton {\n" +
				"bool isVulnerable = false;\n\n" +
				"void vulnChecker(string[] foobar){\n" +
				"\t//in an array of size 100:\n\t//checks if multiples of 3 = \"foo\"\n\t//multiples of 5=\"bar\"\n\t//multiples of 5 have priority\n" +
				"\tif(arrayChecker(foobar) == true){\n" +
				"\tisVulnerable = true;\n" +
				"\t}\n" +
				"}\n" +
				"}";
		}
		if (hackedObject.name.Contains ("ghosts") && hackedObject.GetComponent<ghost>().isHacked == false) {
			mode = 2;
			editCode.GetComponent<InputField> ().text =
				"public class sword {\n" +
				"void averageNumberCalc(){\n" +
				"\t//calculate the average of\n\t//all given numbers\n\tint avg = 0;\n" +
				"\tghost.vulnChecker(avg);\n" +
				"}\n" +
				"}";
			tempText = editCode.GetComponent<InputField> ().text;
			editCode.GetComponent<InputField> ().Select();
			editCode.GetComponent<InputField> ().MoveTextStart (false);
			viewCode.GetComponent<InputField> ().text =
				"public class ghost {\n" +
				"bool isVulnerable = false;\nint[] givenNums = {5,7,3,4,1};\n\n" +
				"void vulnChecker(int x){\n" +
				"\t//checks to see if it is the average\n" +
				"\tif(avgChecker(x) == true){\n" +
				"\tisVulnerable = true;\n" +
				"\t}\n" +
				"}\n" +
				"}";
		}
		if (hackedObject.name.Contains ("moveableBlock") && hackedObject.GetComponent<moveBlock>().isHacked == false) {
			mode = 3;
			editCode.GetComponent<InputField> ().text =
				"public class block {\n" +
				"Position currentPos;\nObject block;\nfloat speed = 10f;\n" +
				"void blockMover(){\n" +
				"\t//move the block\n" +
				"}\n" +
				"}";
			tempText = editCode.GetComponent<InputField> ().text;
			editCode.GetComponent<InputField> ().Select();
			editCode.GetComponent<InputField> ().MoveTextStart (false);
			viewCode.GetComponent<InputField> ().text =
				"public class player {\n" +
				"Position currentPos;\nObject player;\nfloat speed = 10f;\n" +
				"void playerMover(){\n" +
				"\t//finds new position for playerm\n\tPosition newPos = currentPos + ArrowKeyDirection();\n" +
				"\t//moves the player\n\tplayer.Move(newPos * speed);\n" +
				"}\n" +
				"void OnContact(Object objTouched){\n" +
				"\tif(objTouched == block){\n" +
				"\tblock.blockMover();\n\t}\n" +
				"}\n" +
				"}";
		}
	}
	
	// Update is called once per frame
	void Update () {
		EventSystem.current.SetSelectedGameObject (editCode, null);
		editCode.GetComponent<InputField>().OnPointerClick (new PointerEventData (EventSystem.current));
		if(editCode.GetComponent<InputField> ().isFocused == false){
			editCode.GetComponent<InputField> ().MoveTextStart (false);
		}
	}

	public void hackCheck(){
		if (mode == 1) {
			if (editCode.GetComponent<InputField> ().text == (
				"public class sword {\n" +
				"void arrayMaker(){\n" +
				"\tstring[] newArray;\n" +
				"\tfor(int i=0; i<100; i++){\n"+
				"\tif(i%5){newArray[i]=\"bar\";}\n"+
				"\telse if(i%3){newArray[i]=\"foo\";}\n"+
				"\t}\n"+
				"\tskeleton.vulnChecker(newArray);\n" +
				"}\n" +
				"}")) {
				//spawn a hack successful window
				Instantiate(success,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
				hackingComplete ();
			} else {
				//spawn a try again window
				Instantiate(fail,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
			}
		}
		if (mode == 2) {
			if (editCode.GetComponent<InputField> ().text == (
				"public class sword {\n" +
				"void averageNumberCalc(){\n" +
				"\t//calculate the average of\n\t//all given numbers\n" +
				"\tint avg = 0;\n"+
				"\tfor(int i=0; i<ghost.givenNums.length; i++){\n"+
				"\tavg += ghost.givenNums[i];\n"+
				"\t}\n"+
				"\tavg = avg/ghost.givenNums.length;\n"+
				"\tghost.vulnChecker(avg);\n" +
				"}\n" +
				"}")){
				//spawn a hack successful window
				Instantiate(success,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
				hackingComplete ();
			} else {
				//spawn a try again window
				Instantiate(fail,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
			}
		}
		if (mode == 3) {
			if (editCode.GetComponent<InputField> ().text == (
			       "public class block {\n" +
			       "Position currentPos;\nObject block;\nfloat speed = 10f;\n" +
			       "void blockMover(){\n" +
			       "\t//move the block\n" +
			       "\tPosition newPos = -1*(player.currentPos - currentPos);\n" +
			       "\tblock.Move(newPos * speed);\n" +
			       "}\n" +
			       "}")) {
				//spawn a hack successful window
				Instantiate(success,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
				hackingComplete ();
			} else {
				//spawn a try again window
				Instantiate(fail,  Camera.main.ViewportToWorldPoint (new Vector3 (0.5f, 0.5f, 1)), Quaternion.identity);
			}
		}
	}

	void hackingComplete(){
		if (mode == 1) {
			universalFunctions.universalObjectSearch ("skeleton (0)").GetComponent<skeleton> ().isHacked = true;
			universalFunctions.universalObjectSearch ("skeleton (1)").GetComponent<skeleton> ().isHacked = true;
			universalFunctions.universalObjectSearch ("skeleton (2)").GetComponent<skeleton> ().isHacked = true;
			universalFunctions.universalObjectSearch ("skeleton (3)").GetComponent<skeleton> ().isHacked = true;
		}
		if (mode == 2) {
			universalFunctions.universalObjectSearch ("ghosts1").GetComponent<ghost> ().isHacked = true;
			universalFunctions.universalObjectSearch ("ghosts2").GetComponent<ghost> ().isHacked = true;
		}
		if (mode == 3) {
			universalFunctions.universalObjectSearch ("moveableBlock (1)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (2)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (3)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (4)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (5)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (6)").GetComponent<moveBlock> ().isHacked = true;
			universalFunctions.universalObjectSearch ("moveableBlock (7)").GetComponent<moveBlock> ().isHacked = true;
		}

		player.GetComponent<playerControl> ().speed = 20;
		player.GetComponent<playerControl> ().hacking = false;

		Destroy (gameObject);
	}
}
