﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class moveBlock : MonoBehaviour {

	public bool isHacked = false;
	public int frameCounter = 0;

	CharacterController controller;
	void Start(){
		controller = gameObject.GetComponent<CharacterController> ();
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.name.Contains ("player") && isHacked == true) {
			frameCounter++;
			if (frameCounter == 30 ) {
				//change this from a general move function to a movetowards, calculate destination send object towards that
				float force = 1.25f;
				Vector3 dir = -1 * (col.gameObject.transform.position - gameObject.transform.position);
				float tX = Mathf.Abs(dir.x), tY = Mathf.Abs(dir.y);
				if (tX > tY) {dir = new Vector3 (dir.x, 0, 0);}
				if (tY > tX) {dir = new Vector3 (0, dir.y, 0);}
				if(tY == tX) {dir = new Vector3 (0, 0, 0);}
				frameCounter = 0;
				int facing = col.gameObject.GetComponent<playerControl> ().facing;
				switch (facing) {
				case 1:
					if (dir.normalized == Vector3.right) {controller.Move (dir * force);}
					break;
				case 2:
					if (dir.normalized == Vector3.left) {controller.Move (dir * force);}
					break;
				case 3:
					if (dir.normalized == Vector3.up) {controller.Move (dir * force);}
					break;
				case 4:
					if (dir.normalized == Vector3.down) {controller.Move (dir * force);}
					break;
				}
			}
		}
	}
}
