﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class resetBlocks : MonoBehaviour {

	GameObject block1, block2, block3, block4, block5, block6, block7;

	Vector3 b1,b2,b3,b4,b5,b6,b7;
	bool hasReset = false;

	AudioSource audio;
	public AudioClip reset;
	void Start () {
		audio = gameObject.GetComponent<AudioSource> ();
		block1 = universalFunctions.universalObjectSearch ("moveableBlock (1)");
		block2 = universalFunctions.universalObjectSearch ("moveableBlock (2)");
		block3 = universalFunctions.universalObjectSearch ("moveableBlock (3)");
		block4 = universalFunctions.universalObjectSearch ("moveableBlock (4)");
		block5 = universalFunctions.universalObjectSearch ("moveableBlock (5)");
		block6 = universalFunctions.universalObjectSearch ("moveableBlock (6)");
		block7 = universalFunctions.universalObjectSearch ("moveableBlock (7)");
		b1 = block1.transform.position;
		b2 = block2.transform.position;
		b3 = block3.transform.position;
		b4 = block4.transform.position;
		b5 = block5.transform.position;
		b6 = block6.transform.position;
		b7 = block7.transform.position;
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.name.Contains ("player") && hasReset == false) {
			hasReset= true;
			block1.transform.SetPositionAndRotation(b1, Quaternion.identity);
			block2.transform.SetPositionAndRotation(b2, Quaternion.identity);
			block3.transform.SetPositionAndRotation(b3, Quaternion.identity);
			block4.transform.SetPositionAndRotation(b4, Quaternion.identity);
			block5.transform.SetPositionAndRotation(b5, Quaternion.identity);
			block6.transform.SetPositionAndRotation(b6, Quaternion.identity);
			block7.transform.SetPositionAndRotation(b7, Quaternion.identity);
			audio.clip = reset;
			audio.Play ();
		}
	}

	void OnTriggerExit(Collider col){
		if (col.gameObject.name.Contains ("player") && hasReset == true) {
			hasReset = false;
		}
	}
}
